diff --git a/src/TopClass/TopClass_GeomEdge.cxx b/src/TopClass/TopClass_GeomEdge.cxx
new file mode 100644
index 0000000..0dd2a7a
--- /dev/null
+++ b/src/TopClass/TopClass_GeomEdge.cxx
@@ -0,0 +1,247 @@
+// Created on: 2017-02-17
+// Created by: Nikolai BUKHALOV
+// Copyright (c) 1999-2017 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#include <TopClass_GeomEdge.hxx>
+
+#include <BRep_Tool.hxx>
+#include <Extrema_ExtPC.hxx>
+#include <Extrema_ExtPC2d.hxx>
+#include <TopExp.hxx>
+#include <TopExp_Explorer.hxx>
+#include <TopoDS.hxx>
+#include <TopoDS_Face.hxx>
+#include <TopoDS_Vertex.hxx>
+
+//=======================================================================
+//function : Constructor
+//purpose  : 
+//=======================================================================
+TopClass_GeomEdge::TopClass_GeomEdge(const Handle(Geom_Curve)& theC3D,
+                                     const Handle(Geom2d_Curve)& theC2D,
+                                     const Handle(Geom_Surface)& theS,
+                                     const Standard_Real theFPar,
+                                     const Standard_Real theLPar,
+                                     const TopAbs_Orientation theOri,
+                                     const TopClass_GeomVertex &theVf,
+                                     const TopClass_GeomVertex &theVl,
+                                     const Standard_Boolean theIsSameParameter)
+  : myOri(theOri),
+    myVertF(theVf),
+    myVertL(theVl),
+    myIsSameParameter(theIsSameParameter)
+{
+  Init(theC3D, theC2D, theS, theFPar, theLPar);
+}
+
+//=======================================================================
+//function : Constructor
+//purpose  : 
+//=======================================================================
+TopClass_GeomEdge::TopClass_GeomEdge(const TopoDS_Edge& theE,
+                                     const Handle(Geom_Surface)& theSurf,
+                                     const Handle(Geom2d_Curve)& theC2d,
+                                     const Standard_Real theFPar,
+                                     const Standard_Real theLPar)
+  : myTopoEdge(theE)
+{
+  myOri = theE.Orientation();
+  
+  if ((myOri != TopAbs_FORWARD) && (myOri != TopAbs_REVERSED))
+    return;
+
+  TopoDS_Vertex aVf, aVl;
+  TopExp::Vertices(theE, aVf, aVl, Standard_True);
+
+  myVertF.Init(aVf, theE);
+  myVertL.Init(aVl, theE);
+
+  Standard_Real aFPar = 1.0, aLPar = -1.0;
+  const Handle(Geom_Curve) aC3d = BRep_Tool::Curve(theE, aFPar, aLPar);
+
+  myIsSameParameter = (BRep_Tool::SameParameter(theE) && BRep_Tool::SameRange(theE));
+
+  Init(aC3d, theC2d, theSurf, theFPar, theLPar);
+}
+
+//=======================================================================
+//function : Init
+//purpose  : 
+//=======================================================================
+void TopClass_GeomEdge::Init(const Handle(Geom_Curve)& theC3D,
+                             const Handle(Geom2d_Curve)& theC2D,
+                             const Handle(Geom_Surface)& theS,
+                             const Standard_Real theFPar,
+                             const Standard_Real theLPar)
+{
+  if (theC2D.IsNull())
+    return;
+
+  myC2D.Load(theC2D, theFPar, theLPar);
+    
+  if (!theC3D.IsNull())
+    myC3D.Load(theC3D, theFPar, theLPar);
+  else
+    myIsSameParameter = Standard_False;
+
+  if (!theS.IsNull())
+    mySurf.Load(theS);
+  else
+    myIsSameParameter = Standard_False;
+}
+
+//=======================================================================
+//function : Distance3D
+//purpose  : 
+//=======================================================================
+Standard_Real TopClass_GeomEdge::Distance3D(const gp_Pnt &thePt,
+                                            gp_Pnt *thePOnC,
+                                            Standard_Real *theParOnC) const
+{
+  if (IsPseudo())
+  {
+    return -1.0;
+  }
+
+  // Default value for extrema algo.
+  const Standard_Real aTolPar = 1.0e-10;
+
+  Extrema_ExtPC anEG(thePt, myC3D, aTolPar);
+
+  if (!anEG.IsDone() || (anEG.NbExt() == 0))
+  {
+    const Standard_Real aDistF = thePt.SquareDistance(myVertF.GetPnt3D());
+    const Standard_Real aDistL = thePt.SquareDistance(myVertL.GetPnt3D());
+
+    if (aDistF < aDistL)
+    {
+      if (thePOnC)
+        thePOnC->SetXYZ(myVertF.GetPnt3D().XYZ());
+      if (theParOnC)
+        *theParOnC = myVertF.ParameterOnEdge();
+
+      return Sqrt(aDistF);
+    }
+    else // if (aDistL <= aDistF)
+    {
+      if (thePOnC)
+        thePOnC->SetXYZ(myVertL.GetPnt3D().XYZ());
+      if (theParOnC)
+        *theParOnC = myVertL.ParameterOnEdge();
+
+      return Sqrt(aDistL);
+    }
+  }
+
+  const Standard_Integer aNbExt = anEG.NbExt();
+  const Extrema_POnCurv *aNearPoint = 0;
+  Standard_Real aMinSqDist = RealLast();
+
+  for (Standard_Integer i = 1; i <= aNbExt; i++)
+  {
+    const Standard_Real aSqDist = anEG.SquareDistance(i);
+
+    if (aSqDist > aMinSqDist)
+      continue;
+
+    aMinSqDist = aSqDist;
+
+    const Extrema_POnCurv &aEPt = anEG.Point(i);
+    aNearPoint = &aEPt;
+  }
+
+  if (aNearPoint == 0)
+  {
+    return -1.0;
+  }
+
+  if (thePOnC)
+    thePOnC->SetXYZ(aNearPoint->Value().XYZ());
+  if (theParOnC)
+    *theParOnC = aNearPoint->Parameter();
+
+  return Sqrt(aMinSqDist);
+}
+
+//=======================================================================
+//function : Distance2D
+//purpose  : 
+//=======================================================================
+Standard_Real TopClass_GeomEdge::Distance2D(const gp_Pnt2d &thePt,
+                                            gp_Pnt2d *thePOnC,
+                                            Standard_Real *theParOnC) const
+{
+  // Default value for extrema algo.
+  const Standard_Real aTolPar = 1.0e-10;
+
+  Extrema_ExtPC2d anEG(thePt, myC2D, aTolPar);
+
+  if (!anEG.IsDone() || (anEG.NbExt() == 0))
+  {
+    const Standard_Real aParF = myC2D.FirstParameter();
+    const Standard_Real aParL = myC2D.LastParameter();
+
+    const gp_Pnt2d aPtF(myC2D.Value(aParF)), aPtL(myC2D.Value(aParL));
+    const Standard_Real aDistF = thePt.SquareDistance(aPtF);
+    const Standard_Real aDistL = thePt.SquareDistance(aPtL);
+
+    if (aDistF < aDistL)
+    {
+      if (thePOnC)
+        thePOnC->SetXY(aPtF.XY());
+      if (theParOnC)
+        *theParOnC = aParF;
+
+      return Sqrt(aDistF);
+    }
+    else // if (aDistL <= aDistF)
+    {
+      if (thePOnC)
+        thePOnC->SetXY(aPtL.XY());
+      if (theParOnC)
+        *theParOnC = aParL;
+
+      return Sqrt(aDistL);
+    }
+  }
+
+  const Standard_Integer aNbExt = anEG.NbExt();
+  const Extrema_POnCurv2d *aNearPoint = 0;
+  Standard_Real aMinSqDist = RealLast();
+
+  for (Standard_Integer i = 1; i <= aNbExt; i++)
+  {
+    const Standard_Real aSqDist = anEG.SquareDistance(i);
+
+    if (aSqDist > aMinSqDist)
+      continue;
+
+    aMinSqDist = aSqDist;
+
+    const Extrema_POnCurv2d &aEPt = anEG.Point(i);
+    aNearPoint = &aEPt;
+  }
+
+  if (aNearPoint == 0)
+  {
+    return -1.0;
+  }
+
+  if (thePOnC)
+    thePOnC->SetXY(aNearPoint->Value().XY());
+  if (theParOnC)
+    *theParOnC = aNearPoint->Parameter();
+
+  return Sqrt(aMinSqDist);
+}
diff --git a/src/TopClass/TopClass_GeomEdge.hxx b/src/TopClass/TopClass_GeomEdge.hxx
new file mode 100644
index 0000000..04300df
--- /dev/null
+++ b/src/TopClass/TopClass_GeomEdge.hxx
@@ -0,0 +1,230 @@
+// Created on: 2017-02-17
+// Created by: Nikolai BUKHALOV
+// Copyright (c) 1999-2017 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#ifndef _TopClass_GeomEdge_HeaderFile
+#define _TopClass_GeomEdge_HeaderFile
+
+#include <Standard_Type.hxx>
+
+#include <Geom2dAdaptor_Curve.hxx>
+#include <GeomAdaptor_Curve.hxx>
+#include <GeomAdaptor_Surface.hxx>
+#include <Precision.hxx>
+#include <TopClass_GeomVertex.hxx>
+#include <TopoDS_Edge.hxx>
+
+class Geom_Curve;
+class Geom_Surface;
+class Geom2d_Curve;
+class TopoDS_Face;
+
+//! Stores information about 3D-curve and
+//! correspond 2D-curve on the face for some edge
+//! (i.e. geometrical representation of the edge).
+//! This info is used for classifier algorithm only.
+//! 3D-curve can be Null-curve (for pseudo- or 
+//! degenerated-edge).
+//! Also, this class can store 2d-curve only (without 3D-curve
+//! and face). It makes this class compatible with
+//! Geom2dHatch_* classes.
+//! ATTENTIONS!!!
+//!   1. The information about 2D-curve has
+//! priority over the information about 3D one
+//! (e.g. First/Last-parameter are taken from 2D-curve).
+//!   2. This geometrical representation does not store any
+//! information about sharing of several edges. I.e. even if two
+//! edges are shared topologically, their geometrical representations
+//! will be two independent (to each other) edges. Every such edge will
+//! have two independent geometrical vertices (one vertex of
+//! 1st edge will be identical of the vertex of 2nd edge but
+//! these vertices will be different and independent to each other).
+
+class TopClass_GeomEdge
+{
+public:
+  //! Default constructor
+  Standard_EXPORT TopClass_GeomEdge() : myOri(TopAbs_EXTERNAL),
+                                        myIsSameParameter(Standard_False)
+  {};
+
+  //! Constructor. Creates edge, which is bounded by the vertices theVf theVl
+  //! and has orientation theOri. 3D- (theC3D) and 2D- (theC2D) curve on
+  //! the surface theS have range [theFirstParam, theLastParam].
+  //! theToler is 3D-tolerance of the edge (is used for check ON-status).
+  Standard_EXPORT TopClass_GeomEdge(const Handle(Geom_Curve)& theC3D,
+                                    const Handle(Geom2d_Curve)& theC2D,
+                                    const Handle(Geom_Surface)& theS,
+                                    const Standard_Real theFirstParam,
+                                    const Standard_Real theLastParam,
+                                    const TopAbs_Orientation theOri,
+                                    const TopClass_GeomVertex &theVf,
+                                    const TopClass_GeomVertex &theVl,
+                                    const Standard_Boolean theIsSameParameter);
+  
+  //! Constructor. Extracts necessary geometrical information from topological
+  //! edge theE lied in the face theF.
+  //! ATENTION!!!
+  //!   1. theE must have 2D-curve on theF. Otherwise, no object will be created.
+  //!   2. Orientation of *this (geometrical edge) will always match
+  //!     the orientation of theE. So, the application must set
+  //!     correct edge orientation before calling this constructor.
+  Standard_EXPORT TopClass_GeomEdge(const TopoDS_Edge& theE,
+                                    const Handle(Geom_Surface)& theSurf,
+                                    const Handle(Geom2d_Curve)& theC2d,
+                                    const Standard_Real theFPar,
+                                    const Standard_Real theLPar);
+
+  //! Replaces 2d-curve with theC.
+  void Replace2DCurve(const Geom2dAdaptor_Curve& theC,
+                      const TopAbs_Orientation theOri)
+  {
+    myC2D = theC;
+    myOri = theOri;
+  }
+
+  //! Looks for thePOnC, which is nearest point in
+  //! the 3D-curve myC3D to thePt. If (thePOnC != 0)
+  //! the found value will be assigned to thePOnC.
+  //! If (theParOnC != 0) the method will assign to it the
+  //! parameter on myC3D respected to thePOnC.
+  //! Returns the distance between thePt and thePOnC.
+  //! Returns negative value if computation is not possible.
+  Standard_EXPORT Standard_Real Distance3D(const gp_Pnt &thePt,
+                                           gp_Pnt *thePOnC = 0,
+                                           Standard_Real *theParOnC = 0) const;
+ 
+
+  //! Looks for thePOnC, which is nearest point in
+  //! the 2D-curve myC2D to thePt. If thePOnC != 0
+  //! the found value will be assigned to thePOnC.
+  //! If (theParOnC != 0) the method will assign to it the
+  //! parameter on myC2D respected to thePOnC.
+  //! Returns the distance between thePt and thePOnC.
+  //! Returns negative value if computation is not possible.
+  Standard_EXPORT Standard_Real Distance2D(const gp_Pnt2d &thePt,
+                                           gp_Pnt2d *thePOnC = 0,
+                                           Standard_Real *theParOnC = 0) const;
+
+  //! Returns 3D-curve of the edge
+  const GeomAdaptor_Curve& Get3DCurve() const
+  {
+    return myC3D;
+  }
+
+  //! Returns orientation of the edge
+  TopAbs_Orientation GetOrientation() const
+  {
+    return myOri;
+  }
+
+  //! Returns 2D-curve of the edge on mySurf
+  const Geom2dAdaptor_Curve& Get2DCurve() const
+  {
+    return myC2D;
+  }
+
+  //! Returns surface
+  const GeomAdaptor_Surface& GetSurface() const
+  {
+    return mySurf;
+  }
+
+  //! Returns TRUE if the edge is pseudo
+  Standard_Boolean IsPseudo() const
+  {
+    return (myC3D.GetType() == GeomAbs_OtherCurve);
+  }
+
+  //! Returns TRUE if the edge has not been
+  //! initialized yet.
+  Standard_Boolean IsNull() const
+  {
+    return (myC2D.GetType() == GeomAbs_OtherCurve);
+  }
+
+  //! Returns first parameter of the curve of the edge
+  Standard_Real FirstParameter() const
+  {
+    return myC2D.FirstParameter();
+  }
+
+  //! Returns last parameter of the curve of the edge
+  Standard_Real LastParameter() const
+  {
+    return myC2D.LastParameter();
+  }
+
+  //! Returns vertex in the start position of the edge
+  const TopClass_GeomVertex& FirstVertex() const
+  {
+    return myVertF;
+  }
+
+  //! Returns vertex in the end of the edge
+  const TopClass_GeomVertex& LastVertex() const
+  {
+    return myVertL;
+  }
+
+  //! Returns topological representation
+  //! of the edge. Uses only in TopOpeBRep classes.
+  const TopoDS_Edge& GetTopoEdge() const
+  {
+    return myTopoEdge;
+  }
+
+  Standard_Boolean IsSameParameter() const
+  {
+    return myIsSameParameter;
+  }
+
+protected:
+
+  //! Initializes of fields
+  void Init(const Handle(Geom_Curve)& theC3D,
+            const Handle(Geom2d_Curve)& theC2D,
+            const Handle(Geom_Surface)& theS,
+            const Standard_Real theFirstParam,
+            const Standard_Real theLastParam);
+
+private:
+  //! This field is used for compatibility with TopOpeBRep classes
+  //! and must be deleted after these classes will be eliminated.
+  TopoDS_Edge myTopoEdge;
+
+  //! 3D-curve of the edge
+  GeomAdaptor_Curve myC3D;
+
+  //! 2D-curve of the edge
+  Geom2dAdaptor_Curve myC2D;
+
+  //! Surface, which lies 2D-curve on
+  GeomAdaptor_Surface mySurf;
+
+  //! Orientation of the edge
+  TopAbs_Orientation myOri;
+  
+  //! Vertex in the start position of the edge
+  TopClass_GeomVertex myVertF;
+
+  //! Vertex in the end of the edge
+  TopClass_GeomVertex myVertL;
+
+  //! Is equal to TRUE if myC3D and myC2D
+  //! are same-parameter.
+  Standard_Boolean myIsSameParameter;
+};
+
+#endif
\ No newline at end of file
diff --git a/src/TopClass/TopClass_GeomVertex.cxx b/src/TopClass/TopClass_GeomVertex.cxx
new file mode 100644
index 0000000..6242f3b
--- /dev/null
+++ b/src/TopClass/TopClass_GeomVertex.cxx
@@ -0,0 +1,52 @@
+// Created on: 2017-02-17
+// Created by: Nikolai BUKHALOV
+// Copyright (c) 1999-2017 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#include <TopClass_GeomVertex.hxx>
+
+#include <BRep_Tool.hxx>
+#include <TopoDS_Vertex.hxx>
+
+//=======================================================================
+//function : Init
+//purpose  : 
+//=======================================================================
+void TopClass_GeomVertex::Init(const TopoDS_Vertex &theV,
+                               const TopoDS_Edge   &theE)
+{
+  if (theV.IsNull())
+    return;
+
+  // If theV.IsNull() == TRUE then BRep_Tool::Parameter(...)
+  // throws exception.
+  Init(theV, BRep_Tool::Parameter(theV, theE));
+}
+
+//=======================================================================
+//function : Init
+//purpose  : 
+//=======================================================================
+void TopClass_GeomVertex::Init(const TopoDS_Vertex &theV,
+                               const Standard_Real theParameterOnEdge)
+{
+  if (theV.IsNull())
+    return;
+
+  // If theV.IsNull() == TRUE then BRep_Tool::Tolerance(...) and
+  // BRep_Tool::Pnt(...) throw exception.
+
+  myEdgeParameter = theParameterOnEdge;
+  myToler = BRep_Tool::Tolerance(theV);
+  myPoint = BRep_Tool::Pnt(theV);  
+}
diff --git a/src/TopClass/TopClass_GeomVertex.hxx b/src/TopClass/TopClass_GeomVertex.hxx
new file mode 100644
index 0000000..c337f77
--- /dev/null
+++ b/src/TopClass/TopClass_GeomVertex.hxx
@@ -0,0 +1,111 @@
+// Created on: 2017-02-17
+// Created by: Nikolai BUKHALOV
+// Copyright (c) 1999-2017 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#ifndef _TopClass_GeomVertex_HeaderFile
+#define _TopClass_GeomVertex_HeaderFile
+
+#include <Standard_Type.hxx>
+
+#include <gp_Pnt.hxx>
+
+class TopoDS_Edge;
+class TopoDS_Vertex;
+
+//! Stores geometrical information about TopoDS_Vertex,
+//! which is useful for TopClass_GeomEdge class only.
+//! ATTENTION!!! This geometrical representation
+//! does not store any information about sharing this
+//! vertex between several edges. I.e. one geom vertex
+//! is in single geom-edge only.
+
+class TopClass_GeomVertex
+{
+public:
+  //! Default constructor
+  TopClass_GeomVertex() : myToler(-1.0), myEdgeParameter(0.0){}
+
+  //! It is main constructor for initialization of
+  //! this class.
+  TopClass_GeomVertex(const TopoDS_Vertex &theV,
+                      const TopoDS_Edge   &theE)
+  {
+    Init(theV, theE);
+  }
+
+  //! This constructor is used for pseudo-edges (which do not have
+  //! any 3D-representations).
+  TopClass_GeomVertex(const TopoDS_Vertex &theV,
+                      const Standard_Real theParameterOnEdge)
+  {
+    Init(theV, theParameterOnEdge);
+  }
+
+  //! It is main method for initialization of
+  //! this class.
+  Standard_EXPORT void Init(const TopoDS_Vertex &theV,
+                            const TopoDS_Edge   &theE);
+
+  //! This method is used for initialization of pseudo-edges
+  //! (which do not have any 3D-representations).
+  Standard_EXPORT void Init(const TopoDS_Vertex &theV,
+                            const Standard_Real theParameterOnEdge);
+
+  //! Returns TRUE for not initialized object
+  Standard_Boolean IsNull() const
+  {
+    return (myToler < 0.0);
+  }
+
+  //! Returns TRUE if theP is covered by *this
+  Standard_Boolean IsSame(const gp_Pnt& theP) const
+  {
+    if (IsNull())
+      return Standard_False;
+
+    return (theP.SquareDistance(myPoint) < myToler*myToler);
+  }
+
+  //! Returns the parameter of the vertex on the edge.
+  Standard_Real ParameterOnEdge() const
+  {
+    return myEdgeParameter;
+  }
+
+  //! Returns the tolerance of the vertex.
+  Standard_Real Tolerance() const
+  {
+    return myToler;
+  }
+
+  //! Returns 3D-point of the vertex.
+  const gp_Pnt& GetPnt3D() const
+  {
+    return myPoint;
+  }
+
+protected:
+
+private:
+  //! 3D-point of the vertex
+  gp_Pnt myPoint;
+  
+  //! Tolerance of the vertex
+  Standard_Real myToler;
+
+  //! Parameter of the vertex on the edge.
+  Standard_Real myEdgeParameter;
+};
+
+#endif
\ No newline at end of file
diff --git a/src/TopClass/TopClass_RayInfo.hxx b/src/TopClass/TopClass_RayInfo.hxx
new file mode 100644
index 0000000..d9f9348
--- /dev/null
+++ b/src/TopClass/TopClass_RayInfo.hxx
@@ -0,0 +1,164 @@
+// Created on: 2017-02-17
+// Created by: Nikolai BUKHALOV
+// Copyright (c) 1999-2017 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#ifndef _TopClass_RayInfo_HeaderFile
+#define _TopClass_RayInfo_HeaderFile
+
+#include <Standard_Type.hxx>
+
+#include <gp_Lin2d.hxx>
+#include <TopAbs_State.hxx>
+
+//! Describes classification ray, which is directed from
+//! the classified point to some point on an edge of
+//! the classification face.
+class TopClass_RayInfo
+{
+public:
+  //! Default constructor
+  TopClass_RayInfo() :myParam(RealLast()), myClassifState(TopAbs_UNKNOWN), myWeight(0)
+  {
+    myLParamArrs[0] = RealLast();
+    myLParamArrs[1] = RealLast();
+  }
+
+  //! Sets line of the ray
+  void SetLin(const gp_Lin2d& theL)
+  {
+    myLin = theL;
+  }
+
+  //! Sets parameter on the edge corresponding to the intersection
+  //! point between the ray and the edge.
+  void SetParameter(const Standard_Real theParam)
+  {
+    myParam = theParam;
+  }
+
+  //! Sets classification state of the ray.
+  //! This state will be applied as classification result
+  //! if the ray is valid.
+  void SetState(const TopAbs_State theState)
+  {
+    myClassifState = theState;
+  }
+
+  //! Returns line of the ray
+  const gp_Lin2d& GetLine() const
+  {
+    return myLin;
+  }
+
+  //! Returns parameter on the edge correspond to the intersection
+  //! point between the ray and the edge.
+  Standard_Real GetParameter() const
+  {
+    return myParam;
+  }
+
+  //! Returns classification state of the ray.
+  TopAbs_State GetState() const
+  {
+    return myClassifState;
+  }
+
+  //! Returns the weight of the ray.
+  //! Allows determining to what extent this ray
+  //! is valid.
+  unsigned int GetWeight() const
+  {
+    return myWeight;
+  }
+
+  //! Increments myWeight.
+  //! ATTENTION !!! It is impossible to decrease
+  //! this value.
+  void AddPenalty(const unsigned int theWeight = 1)
+  {
+    if (myWeight < (myMaximalWeight - theWeight))
+    {
+      myWeight += theWeight;
+    }
+    else
+    {
+      myWeight = myMaximalWeight;
+    }
+  }
+
+  //! Remember parameter of intersection with an edge
+  void AddParamOnLine(const Standard_Real thePrm)
+  {
+    if (thePrm >= myLParamArrs[1])
+      return;
+
+    if (thePrm < myLParamArrs[0])
+    {
+      myLParamArrs[1] = myLParamArrs[0];
+      myLParamArrs[0] = thePrm;
+    }
+    else
+    {
+      myLParamArrs[1] = thePrm;
+    }
+  }
+
+  //! Comparator method for sorting
+  bool operator<(const TopClass_RayInfo& theOther) const
+  {
+    return myWeight < theOther.myWeight;
+  }
+
+  //! Returns thickness of the section of the face by the ray.
+  //! If the section contains several disconnected regions
+  //! nearest region to the classification point will be taken.
+  Standard_Real MinDeltaInterval() const
+  {
+    if (myLParamArrs[0] == RealLast())
+      return RealLast();
+
+    return (myLParamArrs[1] - myLParamArrs[0]);
+  }
+
+private:
+  //! Ray-direction
+  gp_Lin2d myLin;
+
+  //! Parameter on myLin determined
+  //! by intersection point of myLin
+  //! and the edge.
+  Standard_Real myParam;
+
+  //! Classification state of the ray.
+  //! This state will be applied as classification result
+  //! if the ray is valid.
+  TopAbs_State myClassifState;
+
+  //! 0 if the segment is valid.
+  //! It is incremented
+  //! with every observed abnormality.
+  unsigned int myWeight;
+
+  //! Maximal value for unsigned int type
+  static const unsigned int myMaximalWeight = UINT_MAX;
+
+  //! Stores parameters on myLin correspond to the intersection
+  //! point between this ray and the edges.
+  //! If there are many intersection points then two nearest
+  //! to the classification point will be taken.
+  //! This array is always sorted in ascending order.
+  Standard_Real myLParamArrs[2];
+};
+
+#endif
\ No newline at end of file
diff --git a/src/TopOpeBRep/TopOpeBRep_PointClassifier.cxx b/src/TopOpeBRep/TopOpeBRep_PointClassifier.cxx
index edec333..7072510 100644
--- a/src/TopOpeBRep/TopOpeBRep_PointClassifier.cxx
+++ b/src/TopOpeBRep/TopOpeBRep_PointClassifier.cxx
@@ -66,14 +66,13 @@ void TopOpeBRep_PointClassifier::Load(const TopoDS_Face& F)
 //purpose  : 
 //=======================================================================
 
-TopAbs_State TopOpeBRep_PointClassifier::Classify
-  (const TopoDS_Face& F, 
-   const gp_Pnt2d& P2d, 
-   const Standard_Real Tol)
+TopAbs_State TopOpeBRep_PointClassifier::Classify(const TopoDS_Face& F, 
+                                                  const gp_Pnt2d& P2d, 
+                                                  const Standard_Real theTol3D)
 {
   myState = TopAbs_UNKNOWN;
   Load(F);
-  myState = myTopolTool->Classify(P2d,Tol);
+  myState = myTopolTool->Classify(P2d, theTol3D);
 
   return myState;
 }
diff --git a/src/TopOpeBRep/TopOpeBRep_PointClassifier.hxx b/src/TopOpeBRep/TopOpeBRep_PointClassifier.hxx
index a4248d4..ba9f6f3 100644
--- a/src/TopOpeBRep/TopOpeBRep_PointClassifier.hxx
+++ b/src/TopOpeBRep/TopOpeBRep_PointClassifier.hxx
@@ -45,7 +45,7 @@ public:
   Standard_EXPORT void Load (const TopoDS_Face& F);
   
   //! compute position of point <P> regarding with the face <F>.
-  Standard_EXPORT TopAbs_State Classify (const TopoDS_Face& F, const gp_Pnt2d& P, const Standard_Real Tol);
+  Standard_EXPORT TopAbs_State Classify (const TopoDS_Face& F, const gp_Pnt2d& P, const Standard_Real Tol3D);
   
   Standard_EXPORT TopAbs_State State() const;
 
